<?php
/**
 * RecommendationRequestData
 *
 * PHP version 5
 *
 * @category Class
 * @package  Boxxai\Magic
 * @author   Swaagger Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */

/**
 * Recommendation API 2
 *
 * No description provided (generated by Boxx Codegen https://github.com/Boxx-api/Boxx-codegen)
 *
 * OpenAPI spec version: 1.5.0
 * 
 * Generated by: https://github.com/Boxx-api/Boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the Boxx code generator program.
 * https://github.com/Boxx-api/Boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxxai\Magic\Model;

use \ArrayAccess;

/**
 * RecommendationRequestData Class Doc Comment
 *
 * @category    Class
 * @description recommendation request data
 * @package     Boxxai\Magic
 * @author      Boxx Codegen team
 * @link        https://github.com/Boxx-api/Boxx-codegen
 */
class RecommendationRequestData implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $BoxxModelName = 'recommendation_request_data';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxTypes = [
        'client_id' => 'string',
        'access_token' => 'string',
        'channel_id' => 'string',
        'widget_type' => 'string',
        'widget_instance' => 'string',
        'page_url' => 'string',
        'query' => '\Boxxai\Magic\Model\RecommendationRequestDataQuery'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $BoxxFormats = [
        'client_id' => null,
        'access_token' => null,
        'channel_id' => null,
        'widget_type' => null,
        'widget_instance' => null,
        'page_url' => null,
        'query' => null
    ];

    public static function BoxxTypes()
    {
        return self::$BoxxTypes;
    }

    public static function BoxxFormats()
    {
        return self::$BoxxFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'client_id' => 'client_id',
        'access_token' => 'access_token',
        'channel_id' => 'channel_id',
        'widget_type' => 'widget_type',
        'widget_instance' => 'widget_instance',
        'page_url' => 'page_url',
        'query' => 'query'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'client_id' => 'setClientId',
        'access_token' => 'setAccessToken',
        'channel_id' => 'setChannelId',
        'widget_type' => 'setWidgetType',
        'widget_instance' => 'setWidgetInstance',
        'page_url' => 'setPageUrl',
        'query' => 'setQuery'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'client_id' => 'getClientId',
        'access_token' => 'getAccessToken',
        'channel_id' => 'getChannelId',
        'widget_type' => 'getWidgetType',
        'widget_instance' => 'getWidgetInstance',
        'page_url' => 'getPageUrl',
        'query' => 'getQuery'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['client_id'] = isset($data['client_id']) ? $data['client_id'] : null;
        $this->container['access_token'] = isset($data['access_token']) ? $data['access_token'] : null;
        $this->container['channel_id'] = isset($data['channel_id']) ? $data['channel_id'] : null;
        $this->container['widget_type'] = isset($data['widget_type']) ? $data['widget_type'] : null;
        $this->container['widget_instance'] = isset($data['widget_instance']) ? $data['widget_instance'] : null;
        $this->container['page_url'] = isset($data['page_url']) ? $data['page_url'] : null;
        $this->container['query'] = isset($data['query']) ? $data['query'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['client_id'] === null) {
            $invalid_properties[] = "'client_id' can't be null";
        }
        if ($this->container['access_token'] === null) {
            $invalid_properties[] = "'access_token' can't be null";
        }
        if ($this->container['channel_id'] === null) {
            $invalid_properties[] = "'channel_id' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['client_id'] === null) {
            return false;
        }
        if ($this->container['access_token'] === null) {
            return false;
        }
        if ($this->container['channel_id'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets client_id
     * @return string
     */
    public function getClientId()
    {
        return $this->container['client_id'];
    }

    /**
     * Sets client_id
     * @param string $client_id
     * @return $this
     */
    public function setClientId($client_id)
    {
        $this->container['client_id'] = $client_id;

        return $this;
    }

    /**
     * Gets access_token
     * @return string
     */
    public function getAccessToken()
    {
        return $this->container['access_token'];
    }

    /**
     * Sets access_token
     * @param string $access_token
     * @return $this
     */
    public function setAccessToken($access_token)
    {
        $this->container['access_token'] = $access_token;

        return $this;
    }

    /**
     * Gets channel_id
     * @return string
     */
    public function getChannelId()
    {
        return $this->container['channel_id'];
    }

    /**
     * Sets channel_id
     * @param string $channel_id
     * @return $this
     */
    public function setChannelId($channel_id)
    {
        $this->container['channel_id'] = $channel_id;

        return $this;
    }

     /**
     * Gets widget_type
     * @return string
     */
    public function getWidgetType()
    {
        return $this->container['widget_type'];
    }

    /**
     * Sets widget_type
     * @param string $widget_type
     * @return $this
     */
    public function setWidgetType($widget_type)
    {
        $this->container['widget_type'] = $widget_type;

        return $this;
    }

    /**
     * Gets widget_instance
     * @return string
     */
    public function getWidgetInstance()
    {
        return $this->container['widget_instance'];
    }

    /**
     * Sets widget_instance
     * @param string $widget_instance
     * @return $this
     */
    public function setWidgetInstance($widget_instance)
    {
        $this->container['widget_instance'] = $widget_instance;

        return $this;
    }

    /**
     * Gets page_url
     * @return string
     */
    public function getPageUrl()
    {
        return $this->container['page_url'];
    }

    /**
     * Sets page_url
     * @param string $page_url
     * @return $this
     */
    public function setPageUrl($page_url)
    {
        $this->container['page_url'] = $page_url;

        return $this;
    }

    /**
    /**
     * Gets query
     * @return \Boxxai\Magic\Model\RecommendationRequestDataQuery
     */
    public function getQuery()
    {
        return $this->container['query'];
    }

    /**
     * Sets query
     * @param \Boxxai\Magic\Model\RecommendationRequestDataQuery $query
     * @return $this
     */
    public function setQuery($query)
    {
        $this->container['query'] = $query;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Boxxai\Magic\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Boxxai\Magic\ObjectSerializer::sanitizeForSerialization($this));
    }
}


